#!/usr/local/bin/python2.2

import string
import os
import os.path
import shutil
from time import gmtime, strftime
    

class Manager:

    def getFaxes(self):
	myFax = Faxes()
	dir 	= os.listdir(myFax.faxPath)
	
	for tiff in dir:
	    fax = myFax.get(tiff)
	    myFax.faxList[tiff] = fax   
	return myFax

    def makeBackup(self, Fax):
	for fax in Fax.faxList:
	    backupFax = Backup(Fax)
	    backupFax.make(fax)
	return
	
    def sendMail(self, Fax):
	email = Email(Fax)
	email.send()
	return


class Faxes:
    
    def __init__(self):
	#change these paths to your own wishes.
	# faxPath is the folder where the faxes are saved by the Asterisk software
	# backupPath is used to store the fax data and picture
	# templatePath is the folder with the templates and the images, used for the web.
	# tempPicPath, here is the fax pictures stored before the fax is added
	# tempTxtPath, here is de fax date stored in a txt file before the fax is added.
	# web path have to be the path after apache/htdocs/
	# txtExt, is the extension of the text files. if this is changed at some places you have to change 4 into 3 or 5, see comments 
	# picExt, is the extension of the fax picture. if this is changed at some places you have to change 5 into 3 or 4, see comments
	# see also the comments in web.cgi
	# /projects/home/jhollemans/apache2/htdocs/fcgi/
	self.faxPath 		= '/projects/home/jhollemans/apache2/htdocs/fcgi/fax/images/'
	self.backupPath 	= '/projects/home/jhollemans/apache2/htdocs/fcgi/fax/backup/'
	self.templatePath 	= '/projects/home/jhollemans/apache2/htdocs/fcgi/fax/tmpl/'
	self.tempPicPath	= '/projects/home/jhollemans/apache2/htdocs/fcgi/fax/temppic/'
	self.tempTxtPath	= '/projects/home/jhollemans/apache2/htdocs/fcgi/fax/temptxt/'
	self.web		= '/fcgi/fax/backup/'
	self.txtExt		= '.txt'
	self.picExt		= '.tiff'
	self.link 		= []
	self.faxList		= {}
	
    def get(self, tiff):
	self.file = self.faxPath + tiff
	if os.path.isfile(self.file) == True:
	    # change 5 into the lenght of your picExt
	    if tiff[-5:] == self.picExt:
		myTime 	= Time()
		time 	= myTime.get(self.file)
		self.link.append(self.file)
		return time
	return 

    def copy(self, fax):
	shutil.copy(fax, self.tempPicPath)
	return
    
    def remove(self, fax):
	os.remove(fax)
	return


class Time:
    
    def get(self, file):
	sec = os.path.getmtime(file)
	inc_time = strftime("%d %m %Y %H:%M:%S", gmtime(sec))
	return inc_time

	
class Backup:

    def __init__(self, Fax):
	self.fax = Fax
	
    def make(self, pic):
	self.tiff = string.split(self.fax.file, '/')
	# change 5 into the lenght of your picExt
	tempTxt = self.fax.tempTxtPath + pic[:-5] + self.fax.txtExt
	txt = open(tempTxt, 'w')
	txt.write(self.fax.faxList[pic])
	txt.close()
	    
	year = string.split(self.fax.faxList[pic], ' ')
	os.chdir(self.fax.backupPath)
	try:
	    os.mkdir(year[2])
	    os.chdir(self.fax.backupPath + year[2])

	except:
	    os.chdir(self.fax.backupPath + year[2])
	
	try:
	    os.mkdir(year[1])
	    self.path = year[2] + '/' + year[1]
	    os.chdir(self.fax.backupPath + self.path)
	except:
	    self.path = year[2] + '/' + year[1]
	    os.chdir(self.fax.backupPath + self.path)
		    
	source = self.fax.faxPath + pic
	dest = self.fax.backupPath + self.path + '/' + pic
	shutil.copyfile(source, dest)

	# change 5 into the lenght of your picExt

	if self.tiff[-1][-5:] == self.fax.picExt:
	    backup = pic[:-5] + self.fax.txtExt
	    file = open(backup, 'w')
	    file.write(backup)
	    file.close()
	    text = open(backup, 'w')
	    text.write('%s\n' %self.fax.faxList[pic])
	    text.write('\n')
	    text.write('\n')
	    text.write('\n')
	    text.write('\n')
	    text.close()
		
	return 

    def remove(self, pic, text, dir):
	try:
	    os.remove(pic)
	    os.remove(text)
	except:
	    return
	
	pathmonth = self.fax.backupPath + dir[-3] + '/' + dir[-2]
	pathyear = self.fax.backupPath + dir[-3]
	if os.listdir(pathmonth) == []:
	    os.rmdir(pathmonth)
	if os.listdir(pathyear) == []:
	    os.rmdir(pathyear)
	return


class Email:
    
    def __init__(self, Fax):
	#change the email address + server, the subject, the smtpserver.
	self.fax 	= Fax
	self.From 	= 'name@host.com'
	self.To		= 'name@host.com'
	self.Subject	= 'Fax picture'
	self.web	= 'http://yourApache/fax/web.cgi'
	self.smtpserver = 'smtp.host.com'
		
    def send(self):
	from smtplib import SMTP
	from email.MIMEImage import MIMEImage
	from email.MIMEMultipart import MIMEMultipart
	from email.MIMEText import MIMEText
		
	text 		= MIMEText(self.web)
	msg 		= MIMEMultipart()
	msg['Subject'] 	= self.Subject
	msg['From'] 	= self.From
	msg['To'] 	= self.To
	msg.preamble 	= 'Email with Fax'
	msg.epilogue 	= ''	
	msg.attach(text)

	for fax in self.fax.link:
	    pic 		= open(fax, 'r')
	    img 		= MIMEImage(pic.read())
	    pic.close()
	    msg.attach(img)
	    self.fax.copy(fax)
	    self.fax.remove(fax)
	
	if self.fax.link:
	    #change this to your own smtp server
	    SMTP(self.smtpserver).sendmail(self.From, self.To, msg.as_string())
        return


if __name__ == "__main__":
    myManager = Manager()
    Fax = myManager.getFaxes()
    myManager.makeBackup(Fax)
    myManager.sendMail(Fax)
